org.eclipse.jetty.server

## Class Response

- java.lang.Object
- - org.eclipse.jetty.server.Response

All Implemented Interfaces:
  javax.servlet.http.HttpServletResponse, javax.servlet.ServletResponse

    public class Response
    extends Object
    implements javax.servlet.http.HttpServletResponse

Response.

Implements `HttpServletResponse` from the `javax.servlet.http` package.

### Field Summary

Fields
`static String` `HTTP_ONLY_COMMENT` If this string is found within the comment of a cookie added with `addCookie(Cookie)`, then the cookie will be set as HTTP ONLY.
`static int` `NONE`
`static String` `SET_INCLUDE_HEADER_PREFIX` If a header name starts with this string, the header (stripped of the prefix) can be set during include using only `setHeader(String, String)` or `addHeader(String, String)`.
`static int` `STREAM`
`static int` `WRITER`

### Fields inherited from interface javax.servlet.http.HttpServletResponse

`SC_ACCEPTED, SC_BAD_GATEWAY, SC_BAD_REQUEST, SC_CONFLICT, SC_CONTINUE, SC_CREATED, SC_EXPECTATION_FAILED, SC_FORBIDDEN, SC_FOUND, SC_GATEWAY_TIMEOUT, SC_GONE, SC_HTTP_VERSION_NOT_SUPPORTED, SC_INTERNAL_SERVER_ERROR, SC_LENGTH_REQUIRED, SC_METHOD_NOT_ALLOWED, SC_MOVED_PERMANENTLY, SC_MOVED_TEMPORARILY, SC_MULTIPLE_CHOICES, SC_NO_CONTENT, SC_NON_AUTHORITATIVE_INFORMATION, SC_NOT_ACCEPTABLE, SC_NOT_FOUND, SC_NOT_IMPLEMENTED, SC_NOT_MODIFIED, SC_OK, SC_PARTIAL_CONTENT, SC_PAYMENT_REQUIRED, SC_PRECONDITION_FAILED, SC_PROXY_AUTHENTICATION_REQUIRED, SC_REQUEST_ENTITY_TOO_LARGE, SC_REQUEST_TIMEOUT, SC_REQUEST_URI_TOO_LONG, SC_REQUESTED_RANGE_NOT_SATISFIABLE, SC_RESET_CONTENT, SC_SEE_OTHER, SC_SERVICE_UNAVAILABLE, SC_SWITCHING_PROTOCOLS, SC_TEMPORARY_REDIRECT, SC_UNAUTHORIZED, SC_UNSUPPORTED_MEDIA_TYPE, SC_USE_PROXY`

### Constructor Summary

Constructors
Constructor and Description
`Response(AbstractHttpConnection connection)`

### Method Summary

Methods
`void` `addCookie(javax.servlet.http.Cookie cookie)`
`void` `addCookie(HttpCookie cookie)`
`void` `addDateHeader(String name, long date)`
`void` `addHeader(String name, String value)`
`void` `addIntHeader(String name, int value)`
`void` `complete()`
`boolean` `containsHeader(String name)`
`String` `encodeRedirectUrl(String url)` Deprecated.
`String` `encodeRedirectURL(String url)`
`String` `encodeUrl(String url)` Deprecated.
`String` `encodeURL(String url)`
`void` `flushBuffer()`
`void` `fwdReset()`
`int` `getBufferSize()`
`String` `getCharacterEncoding()`
`long` `getContentCount()`
`String` `getContentType()`
`String` `getHeader(String name)`
`Enumeration` `getHeaders(String name)`
`HttpFields` `getHttpFields()`
`Locale` `getLocale()`
`javax.servlet.ServletOutputStream` `getOutputStream()`
`String` `getReason()`
`static Response` `getResponse(javax.servlet.http.HttpServletResponse response)`
`int` `getStatus()`
`PrintWriter` `getWriter()`
`boolean` `isCommitted()`
`boolean` `isOutputing()`
`boolean` `isWriting()`
`protected void` `recycle()`
`void` `reset()`
`void` `reset(boolean preserveCookies)`
`void` `resetBuffer()`
`void` `sendError(int sc)`
`void` `sendError(int code, String message)`
`void` `sendProcessing()`
`void` `sendRedirect(String location)`
`void` `setBufferSize(int size)`
`void` `setCharacterEncoding(String encoding)`
`void` `setContentLength(int len)`
`void` `setContentType(String contentType)`
`void` `setDateHeader(String name, long date)`
`void` `setHeader(String name, String value)`
`void` `setIntHeader(String name, int value)`
`void` `setLocale(Locale locale)`
`void` `setLongContentLength(long len)`
`void` `setStatus(int sc)`
`void` `setStatus(int sc, String sm)`
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### NONE

    public static final int NONE

See Also:
  Constant Field Values

#### STREAM

    public static final int STREAM

See Also:
  Constant Field Values

#### WRITER

    public static final int WRITER

See Also:
  Constant Field Values

#### SET_INCLUDE_HEADER_PREFIX

    public static final String SET_INCLUDE_HEADER_PREFIX

If a header name starts with this string, the header (stripped of the prefix) can be set during include using only `setHeader(String, String)` or `addHeader(String, String)`.

See Also:
  Constant Field Values

#### HTTP_ONLY_COMMENT

    public static final String HTTP_ONLY_COMMENT

If this string is found within the comment of a cookie added with `addCookie(Cookie)`, then the cookie will be set as HTTP ONLY.

See Also:
  Constant Field Values

### Constructor Detail

#### Response

    public Response(AbstractHttpConnection connection)

### Method Detail

#### getResponse

    public static Response getResponse(javax.servlet.http.HttpServletResponse response)

#### recycle

    protected void recycle()

#### addCookie

    public void addCookie(HttpCookie cookie)

#### addCookie

    public void addCookie(javax.servlet.http.Cookie cookie)

Specified by:
  `addCookie` in interface `javax.servlet.http.HttpServletResponse`

#### containsHeader

    public boolean containsHeader(String name)

Specified by:
  `containsHeader` in interface `javax.servlet.http.HttpServletResponse`

#### encodeURL

    public String encodeURL(String url)

Specified by:
  `encodeURL` in interface `javax.servlet.http.HttpServletResponse`

#### encodeRedirectURL

    public String encodeRedirectURL(String url)

Specified by:
  `encodeRedirectURL` in interface `javax.servlet.http.HttpServletResponse`
See Also:
  `HttpServletResponse.encodeRedirectURL(java.lang.String)`

#### encodeUrl

    @Deprecated
    public String encodeUrl(String url)

Deprecated.

Specified by:
  `encodeUrl` in interface `javax.servlet.http.HttpServletResponse`

#### encodeRedirectUrl

    @Deprecated
    public String encodeRedirectUrl(String url)

Deprecated.

Specified by:
  `encodeRedirectUrl` in interface `javax.servlet.http.HttpServletResponse`

#### sendError

    public void sendError(int code,
                 String message)
                   throws IOException

Specified by:
  `sendError` in interface `javax.servlet.http.HttpServletResponse`
Throws:
  `IOException`

#### sendError

    public void sendError(int sc)
                   throws IOException

Specified by:
  `sendError` in interface `javax.servlet.http.HttpServletResponse`
Throws:
  `IOException`

#### sendProcessing

    public void sendProcessing()
                        throws IOException

Throws:
  `IOException`

#### sendRedirect

    public void sendRedirect(String location)
                      throws IOException

Specified by:
  `sendRedirect` in interface `javax.servlet.http.HttpServletResponse`
Throws:
  `IOException`

#### setDateHeader

    public void setDateHeader(String name,
                     long date)

Specified by:
  `setDateHeader` in interface `javax.servlet.http.HttpServletResponse`

#### addDateHeader

    public void addDateHeader(String name,
                     long date)

Specified by:
  `addDateHeader` in interface `javax.servlet.http.HttpServletResponse`

#### setHeader

    public void setHeader(String name,
                 String value)

Specified by:
  `setHeader` in interface `javax.servlet.http.HttpServletResponse`

#### getHeader

    public String getHeader(String name)

#### getHeaders

    public Enumeration getHeaders(String name)

#### addHeader

    public void addHeader(String name,
                 String value)

Specified by:
  `addHeader` in interface `javax.servlet.http.HttpServletResponse`

#### setIntHeader

    public void setIntHeader(String name,
                    int value)

Specified by:
  `setIntHeader` in interface `javax.servlet.http.HttpServletResponse`

#### addIntHeader

    public void addIntHeader(String name,
                    int value)

Specified by:
  `addIntHeader` in interface `javax.servlet.http.HttpServletResponse`

#### setStatus

    public void setStatus(int sc)

Specified by:
  `setStatus` in interface `javax.servlet.http.HttpServletResponse`

#### setStatus

    public void setStatus(int sc,
                 String sm)

Specified by:
  `setStatus` in interface `javax.servlet.http.HttpServletResponse`

#### getCharacterEncoding

    public String getCharacterEncoding()

Specified by:
  `getCharacterEncoding` in interface `javax.servlet.ServletResponse`

#### getContentType

    public String getContentType()

Specified by:
  `getContentType` in interface `javax.servlet.ServletResponse`

#### getOutputStream

    public javax.servlet.ServletOutputStream getOutputStream()
                                                      throws IOException

Specified by:
  `getOutputStream` in interface `javax.servlet.ServletResponse`
Throws:
  `IOException`

#### isWriting

    public boolean isWriting()

#### isOutputing

    public boolean isOutputing()

#### getWriter

    public PrintWriter getWriter()
                          throws IOException

Specified by:
  `getWriter` in interface `javax.servlet.ServletResponse`
Throws:
  `IOException`

#### setCharacterEncoding

    public void setCharacterEncoding(String encoding)

Specified by:
  `setCharacterEncoding` in interface `javax.servlet.ServletResponse`

#### setContentLength

    public void setContentLength(int len)

Specified by:
  `setContentLength` in interface `javax.servlet.ServletResponse`

#### setLongContentLength

    public void setLongContentLength(long len)

#### setContentType

    public void setContentType(String contentType)

Specified by:
  `setContentType` in interface `javax.servlet.ServletResponse`

#### setBufferSize

    public void setBufferSize(int size)

Specified by:
  `setBufferSize` in interface `javax.servlet.ServletResponse`

#### getBufferSize

    public int getBufferSize()

Specified by:
  `getBufferSize` in interface `javax.servlet.ServletResponse`

#### flushBuffer

    public void flushBuffer()
                     throws IOException

Specified by:
  `flushBuffer` in interface `javax.servlet.ServletResponse`
Throws:
  `IOException`

#### reset

    public void reset()

Specified by:
  `reset` in interface `javax.servlet.ServletResponse`

#### reset

    public void reset(boolean preserveCookies)

#### fwdReset

    public void fwdReset()

#### resetBuffer

    public void resetBuffer()

Specified by:
  `resetBuffer` in interface `javax.servlet.ServletResponse`

#### isCommitted

    public boolean isCommitted()

Specified by:
  `isCommitted` in interface `javax.servlet.ServletResponse`

#### setLocale

    public void setLocale(Locale locale)

Specified by:
  `setLocale` in interface `javax.servlet.ServletResponse`

#### getLocale

    public Locale getLocale()

Specified by:
  `getLocale` in interface `javax.servlet.ServletResponse`

#### getStatus

    public int getStatus()

Returns:
  The HTTP status code that has been set for this request. This will be `200`(`HttpServletResponse.SC_OK`), unless explicitly set through one of the `setStatus` methods.``

#### getReason

    public String getReason()

Returns:
  The reason associated with the current `status`. This will be `null`, unless one of the `setStatus` methods have been called.

#### complete

    public void complete()
                  throws IOException

Throws:
  `IOException`

#### getContentCount

    public long getContentCount()

Returns:
  the number of bytes actually written in response body

#### getHttpFields

    public HttpFields getHttpFields()

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`